/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.kiwi.client.nibctrl;

import java.awt.BorderLayout;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableCellRenderer;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.kiwi.client.metier.EOFournis;
import org.cocktail.kiwi.client.metier.EOMission;
import org.cocktail.kiwi.client.metier.EOMissionPaiement;
import org.cocktail.kiwi.client.metier.EOMissionReimput;
import org.cocktail.kiwi.client.metier.EOReimputaiton;
import org.cocktail.kiwi.client.metier.budget.EOCodeAnalytique;
import org.cocktail.kiwi.client.metier.budget.EODepense;
import org.cocktail.kiwi.client.metier.budget.EOOrgan;
import org.cocktail.kiwi.common.utilities.CocktailConstantes;
import org.cocktail.kiwi.common.utilities.CocktailIcones;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class EditionReimputationsView extends javax.swing.JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7770031412248058797L;
	ZEOTableCellRenderer myRenderer;
	private EODisplayGroup eod;
	private ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;

    /** Creates new form TemplateJPanel */
    public EditionReimputationsView(EODisplayGroup displayGroup, ZEOTableCellRenderer renderer) {

        eod = displayGroup;
        
        myRenderer = renderer;
        
        initComponents();
        initGui();
        
    }

	/** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTable = new javax.swing.JPanel();
        btnExporter = new javax.swing.JButton();
        btnImprimerListe = new javax.swing.JButton();
        btnImprimerAgent = new javax.swing.JButton();

        viewTable.setLayout(new java.awt.BorderLayout());

        btnExporter.setContentAreaFilled(false);

        btnImprimerListe.setText("Liste");
        btnImprimerListe.setToolTipText("Imprimer la liste des ré-imputations de l'exercice sélectionné");
        btnImprimerListe.setContentAreaFilled(false);

        btnImprimerAgent.setText("Ré-imputation");
        btnImprimerAgent.setToolTipText("Imprimer le certificat pour la ré-imputation sélectionnée");
        btnImprimerAgent.setContentAreaFilled(false);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 830, Short.MAX_VALUE)
                        .addContainerGap())
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(btnImprimerAgent, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 129, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnImprimerListe, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 129, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(18, 18, 18)
                        .add(btnExporter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(18, 18, 18))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(38, 38, 38)
                .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 343, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnExporter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnImprimerListe, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnImprimerAgent, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnExporter;
    private javax.swing.JButton btnImprimerAgent;
    private javax.swing.JButton btnImprimerListe;
    protected javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables

    
    
    
    private void initGui() {
            
    	btnImprimerListe.setIcon(CocktailIcones.ICON_PRINTER_16);
    	btnImprimerAgent.setIcon(CocktailIcones.ICON_PRINTER_16);
    	btnExporter.setIcon(CocktailIcones.ICON_EXCEL);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eod, EOMissionReimput.MISSION_PAIEMENT_KEY+"."+EOMissionPaiement.MISSION_KEY + 
    			"."+EOMission.MIS_NUMERO_KEY, "Mis No", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOMissionReimput.MISSION_PAIEMENT_KEY+"."+EOMissionPaiement.MISSION_KEY + 
    			"."+EOMission.FOURNIS_KEY+"."+EOFournis.NOM_KEY, "Nom", 75);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOMissionReimput.MISSION_PAIEMENT_KEY+"."+EOMissionPaiement.MISSION_KEY + 
    			"."+EOMission.FOURNIS_KEY+"."+EOFournis.PRENOM_KEY, "Prénom", 75);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOMissionReimput.MISSION_PAIEMENT_KEY+"."+EOMissionPaiement.MISSION_KEY + 
    			"."+EOMission.MIS_DEBUT_KEY, "Début", 75);
    	col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy HH:mm"));
//    	myCols.add(col);

    	col = new ZEOTableModelColumn(eod, EOMissionReimput.MISSION_PAIEMENT_KEY+"."+EOMissionPaiement.MISSION_KEY + 
    			"."+EOMission.MIS_FIN_KEY, "Fin", 75);
    	col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy HH:mm"));
//    	myCols.add(col);

    	col = new ZEOTableModelColumn(eod, EOMissionReimput.MISSION_PAIEMENT_KEY+"."+EOMissionPaiement.MISSION_KEY + 
    			"."+EOMission.MIS_ETAT_KEY, "Etat", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);

    	col = new ZEOTableModelColumn(eod, EOMissionReimput.REIMPUTATION_KEY+"."+EOReimputaiton.REIM_NUMERO_KEY
    			, "No Reimp", 50);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);

    	col = new ZEOTableModelColumn(eod, EOMissionReimput.REIMPUTATION_KEY+"."+EOReimputaiton.REIM_DATE_KEY
    			, "Date Saisie", 50);
    	col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy"));
    	myCols.add(col);

    	col = new ZEOTableModelColumn(eod, EOMissionReimput.ORGAN_KEY+"."+EOOrgan.ORG_UB_KEY, "UB", 50);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOMissionReimput.ORGAN_KEY+"."+EOOrgan.ORG_CR_KEY, "CR", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOMissionReimput.ORGAN_KEY+"."+EOOrgan.ORG_SOUSCR_KEY, "SOUS CR", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOMissionReimput.CODE_ANALYTIQUE_KEY+"."+EOCodeAnalytique.CAN_CODE_KEY, "ANALYTIQUE", 75);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOMissionReimput.DEPENSE_KEY+"."+EODepense.DEP_TTC_SAISIE_KEY, "Montant", 75);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);

		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		//myEOTable.addListener(myListenerContrat);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTable.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

    
 
    }

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

	public ZEOTableModel getMyTableModel() {
		return myTableModel;
	}

	public void setMyTableModel(ZEOTableModel myTableModel) {
		this.myTableModel = myTableModel;
	}

	public javax.swing.JButton getBtnExporter() {
		return btnExporter;
	}

	public void setBtnExporter(javax.swing.JButton btnExporter) {
		this.btnExporter = btnExporter;
	}

	public javax.swing.JButton getBtnImprimerAgent() {
		return btnImprimerAgent;
	}

	public void setBtnImprimerAgent(javax.swing.JButton btnImprimerAgent) {
		this.btnImprimerAgent = btnImprimerAgent;
	}

	public javax.swing.JButton getBtnImprimerListe() {
		return btnImprimerListe;
	}

	public void setBtnImprimerListe(javax.swing.JButton btnImprimerListe) {
		this.btnImprimerListe = btnImprimerListe;
	}


	

    
}
